<template>
  <div>
    <modal-new-patient> </modal-new-patient>

    <div class="row">
      <div class="ui buttons">
        <button
          class="ui button"
        >
           {{ count > 1 ? 'Patients' : 'Patient' }}
        </button>
        <div
          class="or"
          :data-text="count"
        ></div>
        <button
          class="ui positive button"
          @click="openModalNewPatient"
        >
          Ajouter
        </button>
      </div>
    </div>
    <br/>

    <div
      class="ui" :class="columns + ' column grid'"
      v-if="count"
    >
      <div
        class="column"
        v-for="patient in patients"
        :key="patient._id"
      >
        <div class="ui cards">
          <patient-card
            v-bind:patient="patient"
            @removePatient="removePatient"
            @updatePatient="updatePatient"
          ></patient-card>
        </div>
      </div>
    </div>

    <div class="ui header" v-else>
      Aucun patient présent
    </div>
  </div>
</template>

<script>
import { mapGetters } from 'vuex'

import { adaptiveColumns } from '@/utils/utils'
import store from '@/store/Store'
import PatientCard from './PatientCard'
import ModalNewPatient from './ModalNewPatient'

export default {
  name: 'Patients',
  store,
  data () {
    return {
      columns: 'seven'
    }
  },
  beforeCreate () {
    store.dispatch('PatientsStore/loadPatients')
      .then(
        (response) => {

        },
        (error) => {
          this.$toastr.e(error.response.data.message)
        }
      )
    store.dispatch('DietsStore/loadDiets')
      .then(
        (response) => {

        },
        (error) => {
          this.$toastr.e(error.response ? error.response.data.message : 'Erreur')
        }
      )
  },
  created () {
    this.columns = adaptiveColumns()
  },
  mounted () {
    // eslint-disable-next-line
    $(window).on('resize', () => {
      // eslint-disable-next-line
      this.columns = adaptiveColumns()
    })
  },
  methods: {
    removePatient (id) {
      store.dispatch('PatientsStore/removePatient', id)
        .then((response) => {
          this.$toastr.s(response.firstname + ' ' + response.lastname + ' bien supprimé')
        },
        (error) => {
          this.$toastr.e(error.response.data.message)
        })
    },
    updatePatient () {
      store.dispatch('PatientsStore/loadPatients')
        .then(
          (response) => {

          },
          (error) => {
            this.$toastr.e(error.response.data.message)
          }
        )
    },
    openModalNewPatient () {
      // eslint-disable-next-line
      $('#new-patient-modal')
        .modal('show')
    }
  },
  computed: {
    ...mapGetters({
      patients: 'PatientsStore/patients',
      count: 'PatientsStore/count',
      authUser: 'AuthStore/authUser'
    })
  },
  components: {
    PatientCard,
    ModalNewPatient
  }
}
</script>
